capture log close
drop _all

*************************************************************************
*****  This file creates welfare coefficients by cohort					*
*****  Input file:  CPS_march_6215_ind_couple.dta						*
*************************************************************************
use "C:\Users\osnat\Documents\aosnat\EK\source_data\CPS_march_6215_ind_couple.dta", clear

keep if race == 100

sort cohort_g

by cohort_g: reg real_welfare child18 if marstat!=1 & real_welfare>0 & emp_stat>2 & child18>0 & child18!=. & race==100


. by cohort_g: reg real_welfare child18 if marstat!=1 & real_welfare>0 & emp_stat>2 & chi
> ld18>0 & child18!=. & race==100

-----------------------------------------------------------------------------------------
-> cohort_g = 1925

      Source |       SS           df       MS      Number of obs   =       462
-------------+----------------------------------   F(1, 460)       =     69.68
       Model |  1.2807e+09         1  1.2807e+09   Prob > F        =    0.0000
    Residual |  8.4541e+09       460  18378576.1   R-squared       =    0.1316
-------------+----------------------------------   Adj R-squared   =    0.1297
       Total |  9.7348e+09       461  21116718.5   Root MSE        =      4287

------------------------------------------------------------------------------
real_welfare |      Coef.   Std. Err.      t    P>|t|     [95% Conf. Interval]
-------------+----------------------------------------------------------------
     child18 |   1163.594   139.3927     8.35   0.000     889.6687     1437.52
       _cons |   4649.992   371.2989    12.52   0.000      3920.34    5379.645
------------------------------------------------------------------------------

-----------------------------------------------------------------------------------------
-> cohort_g = 1935

      Source |       SS           df       MS      Number of obs   =     1,030
-------------+----------------------------------   F(1, 1028)      =    367.20
       Model |  7.3994e+09         1  7.3994e+09   Prob > F        =    0.0000
    Residual |  2.0715e+10     1,028  20150901.4   R-squared       =    0.2632
-------------+----------------------------------   Adj R-squared   =    0.2625
       Total |  2.8115e+10     1,029  27322216.8   Root MSE        =      4489

------------------------------------------------------------------------------
real_welfare |      Coef.   Std. Err.      t    P>|t|     [95% Conf. Interval]
-------------+----------------------------------------------------------------
     child18 |   1517.235    79.1773    19.16   0.000     1361.867    1672.602
       _cons |   4317.681   256.6942    16.82   0.000     3813.976    4821.385
------------------------------------------------------------------------------

-----------------------------------------------------------------------------------------
-> cohort_g = 1945

      Source |       SS           df       MS      Number of obs   =     2,003
-------------+----------------------------------   F(1, 2001)      =    307.65
       Model |  4.9494e+09         1  4.9494e+09   Prob > F        =    0.0000
    Residual |  3.2192e+10     2,001  16088050.4   R-squared       =    0.1333
-------------+----------------------------------   Adj R-squared   =    0.1328
       Total |  3.7142e+10     2,002  18552259.5   Root MSE        =      4011

------------------------------------------------------------------------------
real_welfare |      Coef.   Std. Err.      t    P>|t|     [95% Conf. Interval]
-------------+----------------------------------------------------------------
     child18 |   1179.676   67.25687    17.54   0.000     1047.775    1311.577
       _cons |   4749.394   189.9579    25.00   0.000     4376.858     5121.93
------------------------------------------------------------------------------

-----------------------------------------------------------------------------------------
-> cohort_g = 1955

      Source |       SS           df       MS      Number of obs   =     3,289
-------------+----------------------------------   F(1, 3287)      =    325.58
       Model |  4.1272e+09         1  4.1272e+09   Prob > F        =    0.0000
    Residual |  4.1667e+10     3,287  12676187.3   R-squared       =    0.0901
-------------+----------------------------------   Adj R-squared   =    0.0898
       Total |  4.5794e+10     3,288  13927554.6   Root MSE        =    3560.4

------------------------------------------------------------------------------
real_welfare |      Coef.   Std. Err.      t    P>|t|     [95% Conf. Interval]
-------------+----------------------------------------------------------------
     child18 |   975.3533   54.05427    18.04   0.000     869.3699    1081.337
       _cons |   4530.784   130.5812    34.70   0.000     4274.755    4786.813
------------------------------------------------------------------------------

-----------------------------------------------------------------------------------------
-> cohort_g = 1965

      Source |       SS           df       MS      Number of obs   =     2,879
-------------+----------------------------------   F(1, 2877)      =    231.35
       Model |  2.6859e+09         1  2.6859e+09   Prob > F        =    0.0000
    Residual |  3.3401e+10     2,877  11609687.2   R-squared       =    0.0744
-------------+----------------------------------   Adj R-squared   =    0.0741
       Total |  3.6087e+10     2,878  12538901.9   Root MSE        =    3407.3

------------------------------------------------------------------------------
real_welfare |      Coef.   Std. Err.      t    P>|t|     [95% Conf. Interval]
-------------+----------------------------------------------------------------
     child18 |   861.9597   56.66999    15.21   0.000     750.8418    973.0776
       _cons |   3800.542   135.2388    28.10   0.000     3535.367    4065.717
------------------------------------------------------------------------------

-----------------------------------------------------------------------------------------
-> cohort_g = 1975

      Source |       SS           df       MS      Number of obs   =     1,397
-------------+----------------------------------   F(1, 1395)      =    106.50
       Model |   964883016         1   964883016   Prob > F        =    0.0000
    Residual |  1.2639e+10     1,395  9060072.44   R-squared       =    0.0709
-------------+----------------------------------   Adj R-squared   =    0.0703
       Total |  1.3604e+10     1,396  9744759.37   Root MSE        =      3010

------------------------------------------------------------------------------
real_welfare |      Coef.   Std. Err.      t    P>|t|     [95% Conf. Interval]
-------------+----------------------------------------------------------------
     child18 |   764.4601   74.07699    10.32   0.000     619.1458    909.7745
       _cons |   2710.976   165.6531    16.37   0.000      2386.02    3035.932
------------------------------------------------------------------------------

-----------------------------------------------------------------------------------------
-> cohort_g = 1985

      Source |       SS           df       MS      Number of obs   =       577
-------------+----------------------------------   F(1, 575)       =     53.19
       Model |   405960600         1   405960600   Prob > F        =    0.0000
    Residual |  4.3883e+09       575  7631893.41   R-squared       =    0.0847
-------------+----------------------------------   Adj R-squared   =    0.0831
       Total |  4.7943e+09       576   8323436.3   Root MSE        =    2762.6

------------------------------------------------------------------------------
real_welfare |      Coef.   Std. Err.      t    P>|t|     [95% Conf. Interval]
-------------+----------------------------------------------------------------
     child18 |    874.105   119.8499     7.29   0.000      638.708    1109.502
       _cons |   1808.236   247.1148     7.32   0.000     1322.878    2293.593
------------------------------------------------------------------------------

